module M where

data Expr = Entier Int | Mult Expr Expr | Div Expr Expr

eval :: Expr -> Maybe Int
eval (Entier i) = return i
eval (Mult e f) = do x1 <- eval e ; x2 <- eval f ; return (x1 * x2)
eval (Div e f) = do x1 <- eval e ; x2 <- eval f ;
                    if x2 == 0 then fail "div by zero" else
                    return (x1 `div` x2)
