module M where

import Control.Monad.State

data Expr = Entier Int | Mult Expr Expr | Div Expr Expr

test :: Expr
test = Mult (Entier 3) (Div (Entier 6) (Entier 2))

incr :: State Int ()
incr = do x <- get ; put (x+1)

eval :: Expr -> State Int Int
eval (Entier i) = return i
eval (Mult e f) = do incr ; x1 <- eval e ; x2 <- eval f ; return (x1 * x2)
eval (Div e f) = do incr ; x1 <- eval e ; x2 <- eval f ;
                    return (x1 `div` x2)

-- ghci evalS.hs
-- *M> runState (M.eval M.test) 0
-- (9,2)
