module M where

import Control.Monad.Fail
import Control.Monad.State
import Control.Monad.Trans.Maybe
import Data.Functor.Identity

data Expr = Entier Int | Mult Expr Expr | Div Expr Expr

test :: Expr
test = Mult (Entier 3) (Div (Entier 6) (Entier 2))

incr :: (Num i, MonadState i m) => m ()
incr = do x <- get ; put (x+1)

-- The same piece of code can be given several types.

eval :: Expr -> StateT Int Maybe Int
-- eval :: Expr -> MaybeT (StateT Int Identity) Int
-- eval :: Expr -> StateT Int (MaybeT Identity) Int
eval (Entier i) = return i
eval (Mult e f) = do incr ; x1 <- eval e ; x2 <- eval f ; return (x1 * x2)
eval (Div e f) = do incr ; x1 <- eval e ; x2 <- eval f ;
                    if x2 == 0 then
                      Control.Monad.State.fail "div by zero"
                    else
                      return (x1 `div` x2)

-- ghci evalSE.hs
-- *M> runStateT (M.eval M.test) 0
-- Just (9,2)
